/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2014. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteInternalResultTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowManager");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractExplorableTableView");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.ArtifactContentProviderMixin");

(function() {

var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     			= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        			= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      			= com.ibm.rqm.planning.web.client.internal.Constants;
var ConfigurationUriUtil 	= com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
var CommonUtil              = com.ibm.asq.common.web.ui.internal.util.Utility;
var BuildUiUtil				= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var AssetUriUtil 			= com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var WorkflowManager         = com.ibm.rqm.planning.web.ui.internal.view.administration.workflow.WorkflowManager;
var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ERGClient 				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient;
var AbstractExplorableTableView 	= com.ibm.rqm.planning.web.ui.internal.view.table.AbstractExplorableTableView;

dojo.declare("TestSuiteInternalResultTableView.TableProvider", 
		[com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
         com.ibm.rqm.planning.web.ui.internal.view.table.ArtifactContentProviderMixin
         ],
{
    
	constructor: function(args){
		dojo.mixin(this, args);
		this.COLUMNS = {
				INDEX: this.toColumn(Constants.getMessage("labelExecutionOrder"), 5, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_TEXT, 'index', true, true),
				ID: this.toColumn(Constants.getMessage("labelId"), 5, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_RICH_HOVER, 'id', true, true),
				TESTCASE: this.toColumn(Constants.getMessage("labelTestCase"), 15, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_RICH_HOVER, 'testCase', true, true),
				CONFIG: this.toColumn(Constants.getMessage("labelConfig"), 15, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_LINK, 'config', true, true),
				TESTSCRIPT: this.toColumn(Constants.getMessage("labelTestScript"), 15, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_RICH_HOVER, 'testScript', true, true),
				OWNER: this.toColumn(Constants.getMessage("labelOwner"), 8, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'owner', true, true),
				HOSTNAME: this.toColumn(Constants.getMessage("labelHostname"), 8, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'hostname',false, true),
				WEIGHT:this.toColumn(Constants.getMessage("labelWeight"), 5, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'weight',true, true),
				VERDICT:this.toColumn(Constants.getMessage("labelOverallVerdict"), 8, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_RICH_HOVER, 'actualResult',true, true),
				BUILD:this.toColumn(Constants.getMessage("labelBuild"), 5, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'build',true, false),
				CHANNEL:this.toColumn(Constants.getMessage("labelChannel"), 8, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'channel',true, false),
				TESTCASE_STATE_AT_EXECUTION:this.toColumn(Constants.getMessage("labelTestCaseStateAtExecution"), 5, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'testCaseAtExecutionDocumentStateIds',true, false),
				TESTSCRIPT_STATE_AT_EXECUTION:this.toColumn(Constants.getMessage("labelTestScriptStateAtExecution"), 5, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'testScriptAtExecutionDocumentStateIds',true, false)
			};
		
		this.PROFILES = {};
		this.PROFILES.ALL = [this.COLUMNS.INDEX, this.COLUMNS.ID, this.COLUMNS.TESTCASE,this.COLUMNS.CONFIG, this.COLUMNS.TESTSCRIPT,
		                     this.COLUMNS.OWNER,this.COLUMNS.HOSTNAME,this.COLUMNS.WEIGHT,this.COLUMNS.VERDICT,this.COLUMNS.BUILD,
		                     this.COLUMNS.CHANNEL,this.COLUMNS.TESTCASE_STATE_AT_EXECUTION, this.COLUMNS.TESTSCRIPT_STATE_AT_EXECUTION];
		this.columnProfile = null;
  		this.columnProfileName = null;
		this.setProfile("ALL");
	},
	
	toColumn: function(name, width, groupable, alignment, type, rowName, sortable, visible) {
       return 	{
           name: name,
           width: width,
           groupable: groupable,
           alignment: alignment,
           type: type,
           rowName: rowName,
           isVisible: visible,
           dbName: rowName,
           sortable: sortable
       };
 	},

	getProfile: function() {
		return this.columnProfile;
	},

	getProfileName: function() {
		return this.columnProfileName;
	},
       
   setProfile: function(/* string */ profile) {
       if (this.PROFILES[profile]) {
           this.columnProfileName = profile;
           this.columnProfile = this.PROFILES[profile];
       }
   },
	
    getNumColumns: function(content){
    	return this.columnProfile.length;
    },
    
    getColumnIdName: function(index){
    	var column = this.getProfile()[index];
        return column.dbName;
    },

    getColumnHeading: function(content, index)
    {
    	var column = this.columnProfile[index];
        return column.name;
    },

    getColumnHeadingAlignment: function(atColumnIndex)
    {
    	return this.columnProfile[atColumnIndex].alignment;
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
    	return this.columnProfile[atColumnIndex].groupable; 
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
    	var colInfo = this.columnProfile[atColumnIndex];
        return (colInfo.sortable != undefined) ? colInfo.sortable : false;   
    },
	
	getIsColumnVisible: function(atColumnIndex){
		return this.columnProfile[atColumnIndex].isVisible;
	},
    
    getColumnWidth: function(content, atColumnIndex)
    {
    	var column = this.columnProfile[atColumnIndex];
        return column.width;
    },
    
    getContentObjects: function(content)
    {
    	return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_row_for_suite_internal_result_" + rowData.id;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex)
    {
    	var type = this.columnProfile[atColumnIndex].type;
 	   	var column = this.columnProfile[atColumnIndex];
 	   	var rowName = column.rowName;
 	    rowData = rowData.result;
 	   	//Over-ride display type based on the content of the row
    	if(rowName == this.COLUMNS.CONFIG.rowName){
            type = rowData.configName ? TableConstants.RENDER_TYPE_LINK : TableConstants.RENDER_TYPE_TEXT;
    	}else if(rowName == this.COLUMNS.HOSTNAME.rowName){
            type = rowData.machine &&  rowData.machineItemId ? TableConstants.RENDER_TYPE_LINK : TableConstants.RENDER_TYPE_TEXT;
    	}else if(rowName == this.COLUMNS.BUILD.rowName){
			type = rowData.buildName ? TableConstants.RENDER_TYPE_LINK :TableConstants.RENDER_TYPE_TEXT;
        }
        return type;
    },
    
    getChannelNames: function(rowData)
    {
    	var channel = rowData.channels; 
    	var channelNames = [];   	
    	if(channel != null){
    		var channelLen = channel.length;
	    	for(var j=0; j<channelLen; j++)
			{
	    		channelNames.push(channel[j].name);	    		
			}
    	}
		return channelNames.length > 0 ? channelNames.join(", ") : Constants.UNASSIGNED_CHANNEL_NAME;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return this.columnProfile[atColumnIndex].alignment;
    },
    
    getCellRawData: function(rowData, atColumnIndex)
    {
		var column = this.columnProfile[atColumnIndex];
        if(column.name == this.COLUMNS.VERDICT.name){
            return (rowData.result.state ? rowData.result.state.id : "");
        }
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
    	var val = "";
        var column = this.columnProfile[atColumnIndex];
        var rowName = column.rowName;
        switch(rowName) {
        	case this.COLUMNS.INDEX.rowName: 
        		val = rowData.index;//ID
        		break;
        	case this.COLUMNS.ID.rowName: 
                val = rowData.result.id;//ID
                break;
            case this.COLUMNS.TESTCASE.rowName: 
                val = rowData.result.testCase.name;//Test case name
                break;
            case this.COLUMNS.CONFIG.rowName: 
                val = rowData.result.configName ? rowData.result.configName : Constants.getMessage("labelUnassigned"); 
                break;
            case this.COLUMNS.TESTSCRIPT.rowName: 
                val = rowData.result.scriptName ? rowData.scriptName : ""; //TestScript Name
                break;
            case this.COLUMNS.OWNER.rowName:
            	val = rowData.result.owner ? rowData.result.owner.name : "";//Owner  
            	break;
            case this.COLUMNS.HOSTNAME.rowName:
                val = rowData.result.machine ? rowData.result.machine : "";
                if(rowData.result.scriptTypeId && rowData.result.scriptTypeId == "com.ibm.rqm.planning.common.scripttype.manual"){
                	val = Constants.getMessage("labelLocalComputer");//Machine name
                }
                break;          
            case this.COLUMNS.WEIGHT.rowName:
                val = rowData.result.weight;//Weight
                break;  
            case this.COLUMNS.VERDICT.rowName:
                val = rowData.result.state ? rowData.result.state.name : Constants.getMessage("labelUnknown");//Result verdict
                break; 
            case this.COLUMNS.BUILD.rowName:
				val = rowData.result.buildName ? rowData.result.buildName : Constants.getMessage("labelNA"); //Build name
				break;
            case this.COLUMNS.CHANNEL.rowName:
				val = this.getChannelNames(rowData.result);//Channel names
				break;
            case this.COLUMNS.TESTCASE_STATE_AT_EXECUTION.rowName://Historical testcase state at the time of execution
				var testCaseAtExecutionWorkflowState = rowData.result.historicalTestCase ? rowData.result.historicalTestCase.workflowState : null;
				val = testCaseAtExecutionWorkflowState ? (WorkflowManager.getStateNameById(testCaseAtExecutionWorkflowState, Constants.TYPE_CASE) || testCaseAtExecutionWorkflowState) : "";
				break;
            case this.COLUMNS.TESTSCRIPT_STATE_AT_EXECUTION.rowName://Historical testscript state at the time of 
				var testScriptAtExecutionWorkflowState = rowData.result.historicalTestScript ? rowData.result.historicalTestScript.workflowState : null;
				val = testScriptAtExecutionWorkflowState ? (WorkflowManager.getStateNameById(testScriptAtExecutionWorkflowState, Constants.TYPE_SCRIPT) || testScriptAtExecutionWorkflowState) : "";
				break;
        }
        return val;
    },

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        var column = this.columnProfile[atColumnIndex];
        var rowName = column.rowName;
        if(rowName == this.COLUMNS.TESTCASE.rowName) {
            val = {
                label: rowData.result.testCase.name,
                decorateImage: ImageCache.TEST_CASE,
                noUpdateLabel: true,
                uri: CommonUtil.getQmResourceLinkUri(CommonUtil.TYPE_CASE, rowData.result.testCase.versionableItemId),
                openInTab: true,
                presentationUri: Utility.getTestCaseURI(rowData.result.testCase.id)
            };
        }
		else if(rowName == this.COLUMNS.CONFIG.rowName) {
            val = {};//Configuration
            if(rowData.result.configId)
            	val['href'] = ConfigurationUriUtil.getEditConfigurationURI(rowData.result.configId);
        }
        else if (rowName == this.COLUMNS.TESTSCRIPT.rowName) {
           	val = {};
           	if(rowData.result.scriptId){
           	    val.label = rowData.result.scriptName;
                val.decorateImage = ImageCache.TEST_SCRIPT,
				val.noUpdateLabel = true;
				val.uri = CommonUtil.getQmResourceLinkUri(CommonUtil.TYPE_SCRIPT, rowData.result.scriptVersionableItemId);
				val.openInTab = true;
				val.presentationUri = Utility.getTestScriptURI(rowData.result.scriptId, Utility.CONSTRUCTION_PERSPECTIVE);
			}
        }
        else if (rowName == this.COLUMNS.HOSTNAME.rowName) {
           	val = {};
			if(rowData.result.machine){
				val.href = AssetUriUtil.getViewAssetDetailURI( "Machine", rowData.result.machineItemId);
			}
        }
		else if (rowName == this.COLUMNS.VERDICT.rowName) {
            val = {
                label: Utility.getStatusText(rowData.result),
                uri: CommonUtil.getQmResourceLinkUri(CommonUtil.TYPE_EXECUTION_RESULT, rowData.result.itemId),
                openInTab: true,
                presentationUri: Utility.getResultURI({resultItemId: rowData.result.itemId})
            };
       }
	   else if (rowName == this.COLUMNS.ID.rowName) {
            val = {
                label: rowData.result.id,
                uri: CommonUtil.getQmResourceLinkUri(CommonUtil.TYPE_EXECUTION_RESULT, rowData.result.itemId),
                openInTab: true,
                noUpdateLabel: true,               
                noImage: true,
                presentationUri: Utility.getResultURI({resultItemId: rowData.result.itemId})
            };
       }
	   else if(rowName == this.COLUMNS.BUILD.rowName && rowData.result.buildId){
			val = {};//Build
			val.href = BuildUiUtil.getBuildRecordURI(rowData.result.buildId);
		}	  
        return val;
    }
    
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteInternalResultTableView", 
		AbstractExplorableTableView,
{    
	editable: true,
    pageSize: TableConstants.MIN_PAGE_SIZE,
    
    constructor: function(args) {
    	dojo.mixin(this, args);
    	this.showInitLoadProgress = false;
        this.showQueryFilters = false;
	 },

    postCreate: function() 
    {
    	this.skipUpdateOnQuerySelectionChanged = true;
        this.inherited("postCreate", arguments);
    	this._supportsArtifactSummary= false;
    	this._supportsComprehensive = false;
    	this._supportsHistory = false; 
    	this._supportsTableSummary =  false;
    	
		this.setSearchFunction(dojo.hitch(ERGClient, "searchExecutionResultGroupStepResults"));
        this.setSearchCallback(dojo.hitch(this, "refresh"));
        this.setResponseHandlerType(ServiceResponseHandler);

        if (!this.projectAreaItemId) {
        	this.projectAreaItemId = jazz.app.context.get().itemId;
        }

        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
			tableId: "RQM-SUITE-RESULT-TC-TABLEVIWER",
			showFilterControl:true,
			showViewModeControl: false,
			allowAdjustSettings: true,
			autoSaveSettings: true,
			sortByColumn: 0
		});        
        this._tableViewerNode.appendChild(tableViewer.domNode);
        tableViewer.setContent([]);
//        tableViewer.setContentPageSize(10);
        this.provider = this._constructTableContentProvider();
        tableViewer.setContentProvider(this.provider);
        tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelTestSuiteResult")));
        tableViewer.setTableRowsCheckable(false, false);
		tableViewer.show();
		  
		this.tableViewer = tableViewer;
		this.initRunQuery();
    },
	
	refresh: function(content){
		if (this.updatePageOnly) {
            this.provider.loadPageContent(content);
        }
        else{
        	this.tableViewer.setContent(content);
    		this.tableViewer.refresh();
        }
	},
	
	_constructTableContentProvider: function() {
        //create the table provider
        return new TestSuiteInternalResultTableView.TableProvider({
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            ergItemId: this.ergItemId,

            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
            	this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });     
    },
	
	 _prepareQueryArgs: function(filterArgs, updatePageOnly) {
         var args = this.inherited("_prepareQueryArgs", arguments);
         if(this.ergId){
        	 args.id = this.ergId;
         }else{
        	 args.id = null;
         }
         return args;
     }
	
});

})();
