/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.shared.client.internal.model.PlanModel");

dojo.require("com.ibm.jdojo.lang.Exception");
dojo.require("com.ibm.jdojo.lang.JavaScriptException");
dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.jdojo.util.Assert");
dojo.require("com.ibm.team.apt.api.client.IPlanElementDelta");
dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.client.IPlanModel");
dojo.require("com.ibm.team.apt.api.client.IResolvedPlan");
dojo.require("com.ibm.team.apt.api.client.internal.IBatchLoadingSupport");
dojo.require("com.ibm.team.apt.api.client.internal.IExecutionEnvironment");
dojo.require("com.ibm.team.apt.api.client.internal.PlanningAttributeIdentifierImpl");
dojo.require("com.ibm.team.apt.api.client.util.Flag");
dojo.require("com.ibm.team.apt.api.common.ItemType");
dojo.require("com.ibm.team.apt.shared.client.internal.model.PlanAttributeRegistry");
dojo.require("com.ibm.team.apt.shared.client.internal.model.PlanElement");
dojo.require("com.ibm.team.apt.shared.client.internal.model.PlanElementProfile");
dojo.require("com.ibm.team.apt.shared.client.internal.model.PlanModelDeltaBuilder");
dojo.require("com.ibm.team.apt.shared.client.internal.model.adapters.ResolvedPlan");
dojo.require("com.ibm.team.apt.shared.client.internal.util.CountingFuture");
dojo.require("com.ibm.team.apt.shared.client.internal.util.Future");
dojo.require("dojo.i18n");
dojo.require("dojo.string");

dojo.requireLocalization("com.ibm.team.apt.shared.client.internal.model", "Messages");

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.shared.client.internal.model", "Messages");

var jdojo2= com.ibm.jdojo;
var lang= jdojo2.lang;
var Exception= lang.Exception;
var JavaScriptException= lang.JavaScriptException;
var jdojo= lang.Runtime;
var Assert= jdojo2.util.Assert;
var apt= com.ibm.team.apt;
var api= apt.api;
var client= api.client;
var Type= client.IPlanElementDelta.Type;
var IPlanItem= client.IPlanItem;
var IPlanModel= client.IPlanModel;
var IResolvedPlan= client.IResolvedPlan;
var internal= client.internal;
var IBatchLoadingSupport= internal.IBatchLoadingSupport;
var IExecutionEnvironment= internal.IExecutionEnvironment;
var PlanningAttributeIdentifierImpl= internal.PlanningAttributeIdentifierImpl;
var Flag= client.util.Flag;
var ItemType= api.common.ItemType;
var internal2= apt.shared.client.internal;
var model= internal2.model;
var PlanAttributeRegistry= model.PlanAttributeRegistry;
var PlanElement= model.PlanElement;
var PlanElementProfile= model.PlanElementProfile;
var PlanModelDeltaBuilder= model.PlanModelDeltaBuilder;
var PlanElementDelta= PlanModelDeltaBuilder.PlanElementDelta;
var ResolvedPlan= model.adapters.ResolvedPlan;
var util= internal2.util;
var CountingFuture= util.CountingFuture;
var Future= util.Future;
var string= dojo.string;

var PlanModel= dojo.declare("com.ibm.team.apt.shared.client.internal.model.PlanModel", PlanElement, {

	//fMyId: null,

	//fExecutionEnv: null,

	//fgMutex: null,

	//fPlanElements: null,

	//fSortedPlanElements: null,

	//fDisposed: null,

	//fgAttributeInitTimeout: null,

	//fAttributeRegistry: null,

	constructor: function(planRecord, attributes, workerFactory) {
		this.inherited(arguments, [planRecord, null]);
		this.fMyId= PlanModel.fgIdPool++;
		this.fgMutex= {};
		this.fPlanElements= {};
		this.fDisposed= false;
		this.fgAttributeInitTimeout= 1000 * 30;
		this.fCreationListenerList= [];
		this.fListenerList= [];
		this.fDeltaBuilderConnectionCounter= 0;
		this.fAttrInitMap= {};
		this.fAttrInitWorker= dojo.hitch(this, function() {
			var isDone= this.fExecutionEnv.runWithLock(dojo.hitch(this, function() {
				if (this.fCurrentInitializationContext != null) {
					var attributesTimestamp= this.fCurrentInitializationContext.attributesTimestamp;
					var now= new Date().getTime();
					var warned= false;
					var $subject15= jdojo.getProperties(attributesTimestamp);
					var $length15= $subject15.length;
					for (var $count15= 0; $count15 < $length15; $count15++){
						var attributeId= $subject15[$count15];
						var timestamp= attributesTimestamp[attributeId];
						if (now - timestamp > this.fgAttributeInitTimeout) {
							console.warn(string.substitute("${0} HAS BEEN GONE MISSING - WAITING > ${1}ms", [attributeId , this.fgAttributeInitTimeout]));
							attributesTimestamp[attributeId]= now;
							warned= true;
						}
					}
					if (warned) {
						console.warn(string.substitute("WAITING FOR SOME LATE ATTRIBUTES - I AM #${0}", [this.fMyId ]));
					}
					return false;
				}
				var candidateAttrs= jdojo.getProperties(this.fAttrInitMap);
				if (candidateAttrs.length === 0) {
					return true;
				}
				var candidateAttrsIds= new Array(candidateAttrs.length);
				for (var i= 0; i < candidateAttrs.length; i++){
					candidateAttrsIds[i]= new PlanningAttributeIdentifierImpl(candidateAttrs[i]);
				}
				var fringe= this.fAttributeRegistry.fringeFor(candidateAttrsIds);
				var currentAttributes= {};
				for (var i= 0; i < fringe.length; i++){
					var attrId= fringe[i].getId();
					currentAttributes[attrId]= this.fAttrInitMap[attrId];
					delete this.fAttrInitMap[attrId];
				}
				var onAllFringeAttributesInitialized= new Future();
				onAllFringeAttributesInitialized.setCallback(dojo.hitch(this, function(result) {
					this.disconnectDeltaBuilder();
					var $subject16= jdojo.getValues(currentAttributes);
					var $length16= $subject16.length;
					for (var $count16= 0; $count16 < $length16; $count16++){
						var attrData= $subject16[$count16];
						attrData.fFuture.callback(result);
					}
					this.fCurrentInitializationContext= null;
					this.fAttrInitWorker();
				}));
				onAllFringeAttributesInitialized.setErrCallback(dojo.hitch(this, function(result) {
					this.disconnectDeltaBuilder();
					var $subject17= jdojo.getValues(currentAttributes);
					var $length17= $subject17.length;
					for (var $count17= 0; $count17 < $length17; $count17++){
						var attrData= $subject17[$count17];
						attrData.fFuture.errback(result);
					}
					this.fCurrentInitializationContext= null;
					this.fAttrInitWorker();
				}));
				this.connectDeltaBuilder();
				this.fCurrentInitializationContext= new AttributeInitializationContext();
				this.doInitializeAttributes(this.fCurrentInitializationContext, fringe, currentAttributes, onAllFringeAttributesInitialized);
				return false;
			}), this.fgMutex);
			return isDone ? IExecutionEnvironment.DONE : 500;
		});
		this.fAttributeInitializeCalledAtLeastOnce= {};
		this.fExecutionEnv= workerFactory;
		this.fAttributeRegistry= new PlanAttributeRegistry(attributes);
	},

	getAdapter: function(interfaceType) {
		if (interfaceType === IResolvedPlan) {
			return new ResolvedPlan(this);
		}
		return this.inherited("getAdapter", arguments, [interfaceType]);
	},

	registerPlanElement: function(planElement) {
		if (!(!(planElement.getIdentifier() in this.fPlanElements))) Assert.fail("Illegal argument - planElement is registered already or its uuid isn't unique", "PlanModel:94");
		this.fPlanElements[planElement.getIdentifier()]= planElement;
	},

	unInitialize: function(planElements) {
		var attributes= this.fAttributeRegistry.getAllAttributes();
		for (var i= 0; i < attributes.length; i++){
			var initializedElements= PlanElementProfile.subsetOfInitialized(attributes[i], planElements);
			if (initializedElements.length !== 0) {
				attributes[i].unInitialize(this, initializedElements);
			}
		}
	},

	dispose: function() {
		this.fExecutionEnv.newWorker(dojo.hitch(this, function() {
			if (this.attrInitWorkerIsAlive()) {
				return 100;
			}
			this.unInitialize(this.getAllPlanElements());
			this.fDisposed= true;
			return IExecutionEnvironment.DONE;
		})).schedule(0);
	},

	isDisposed: function() {
		return this.fDisposed;
	},

	getPlanModel: function() {
		return this;
	},

	removePlanElements: function(elements) {
		this.compoundChange(dojo.hitch(this, function(deltaBuilder) {
			var $subject= elements;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var element= $subject[$count];
				var identifier= element.getIdentifier();
				if ((identifier in this.fPlanElements)) {
					delete this.fPlanElements[identifier];
					deltaBuilder.removed(element);
				}
			}
			dojo.publish(IPlanModel.PLAN_ELEMENT_REMOVED_FROM_MODEL_EVENT_ID, elements);
			return null;
		}));
	},

	createPlanElements: function(items, attributes, future) {
		this.checkPlanModel();
		attributes= attributes.slice(0);
		var result= [];
		var $subject2= items;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var item= $subject2[$count2];
			var planElement= this.getPlanElement(item.getItemId());
			if (planElement == null) {
				planElement= new PlanElement(item, this);
			}
			result.push(planElement);
		}
		var onAttributeInitialize= new Future();
		onAttributeInitialize.setErrCallback(future.getErrCallback());
		onAttributeInitialize.setCallback(dojo.hitch(this, function(_void) {
			var allPlanElementDeltas= {};
			var $subject3= result;
			var $length3= $subject3.length;
			for (var $count3= 0; $count3 < $length3; $count3++){
				var planElement= $subject3[$count3];
				var delta= new PlanElementDelta(planElement);
				delta.type(Type.Added);
				allPlanElementDeltas[planElement.getIdentifier()]= delta;
			}
			this.fireEvent(allPlanElementDeltas);
			future.callback(result);
		}));
		for (var i= 0; i < this.fCreationListenerList.length; i++){
			var additionalAttributes= null;
			try {
				additionalAttributes= this.fCreationListenerList[i](ItemType.WorkItem);
			} catch (e) {
				if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
					console.log(e);
				} else {
					throw e;
				}
			}
			if (additionalAttributes != null && additionalAttributes.length !== 0) {
				Array.prototype.push.apply(attributes, additionalAttributes);
			}
		}
		this.initialize(attributes, result, onAttributeInitialize);
	},

	//fCreationListenerList: null,

	addCreationListener: function(listener) {
		this.fCreationListenerList.push(listener);
	},

	removeCreationListener: function(listener) {
		for (var i= 0; i < this.fCreationListenerList.length; i++){
			if (this.fCreationListenerList[i] === listener) {
				this.fCreationListenerList.splice(i, 1);
				i--;
			}
		}
	},

	getPlanElement: function(uuid) {
		if (this.getIdentifier() === uuid) 
			return this;
		var result= this.fPlanElements[uuid];
		if (result !== undefined) 
			return result;
		return null;
	},

	getPlanElementByUri: function(uri) {
		var $subject4= jdojo.getValues(this.fPlanElements);
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var planElement= $subject4[$count4];
			var planItem= planElement.getAdapter(IPlanItem);
			if (planItem != null && uri === planItem.getUri()) {
				return planElement;
			}
		}
		return null;
	},

	getPlanElementsSortedByRank: function(sourceElement) {
		var elements= this.getAllPlanElements();
		elements.sort(function(left, right) {
			var leftPlanItem= left.getAdapter(IPlanItem);
			var rightPlanItem= right.getAdapter(IPlanItem);
			if (leftPlanItem != null && rightPlanItem != null) {
				return (leftPlanItem).compareTo(rightPlanItem);
			}
			return -1;
		});
		return elements;
	},

	getSortedPlanElements: function() {
		return dojo.map(this.fSortedPlanElements, function(element, index, array) {
			return element.fElement;
		});
	},

	setSortedPlanElements: function(sortedPlanElements) {
		this.fSortedPlanElements= sortedPlanElements;
	},

	getAllPlanElements: function() {
		var result= [];
		var properties= jdojo.getProperties(this.fPlanElements);
		var $subject5= properties;
		var $length5= $subject5.length;
		for (var $count5= 0; $count5 < $length5; $count5++){
			var property= $subject5[$count5];
			result.push(this.fPlanElements[property]);
		}
		return result;
	},

	getAllDefinedPlanElements: function(attributes) {
		var result= [];
		var properties= jdojo.getProperties(this.fPlanElements);
		var isDefined;
		var $subject6= properties;
		var $length6= $subject6.length;
		for (var $count6= 0; $count6 < $length6; $count6++){
			var property= $subject6[$count6];
			isDefined= true;
			var $subject7= attributes;
			var $length7= $subject7.length;
			for (var $count7= 0; $count7 < $length7; $count7++){
				var attribute= $subject7[$count7];
				if (!this.fPlanElements[property].isDefined(attribute)) {
					isDefined= false;
					break;
				}
			}
			if (isDefined) 
				result.push(this.fPlanElements[property]);
		}
		return result;
	},

	getAllAttributes: function() {
		return this.fAttributeRegistry.getAllAttributes();
	},

	findAttribute: function(attributeId) {
		return this.fAttributeRegistry.getAttribute(attributeId);
	},

	//fListenerList: null,

	addListener: function(listener) {
		this.fListenerList.push(listener);
	},

	removeListener: function(listener) {
		for (var i= 0; i < this.fListenerList.length; i++){
			if (this.fListenerList[i] === listener) {
				this.fListenerList.splice(i, 1);
				i--;
			}
		}
	},

	fireEvent: function(allPlanElementDeltas) {
		var listeners= [].concat(this.fListenerList);
		var allDeltas= jdojo.getValues(allPlanElementDeltas);
		var $subject8= listeners;
		var $length8= $subject8.length;
		for (var $count8= 0; $count8 < $length8; $count8++){
			var listener= $subject8[$count8];
			try {
				listener.onChanges(allDeltas);
			} catch (e) {
				if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
					console.log(e);
				} else {
					throw e;
				}
			}
		}
	},

	compoundChange: function(code) {
		this.checkPlanModel();
		var deltaBuilder= this.connectDeltaBuilder();
		try {
			return code(deltaBuilder);
		} finally {
			this.disconnectDeltaBuilder();
		}
	},

	//fDeltaBuilderConnectionCounter: null,

	//fDeltaBuilder: null,

	connectDeltaBuilder: function() {
		var $this= this;
		var connectRunnable= dojo.hitch(this, function() {
			if (!(this.fDeltaBuilder != null || this.fDeltaBuilderConnectionCounter === 0)) Assert.fail("this.fDeltaBuilder != null || this.fDeltaBuilderConnectionCounter === 0", "PlanModel:341");
			if (this.fDeltaBuilder == null) {
				this.fDeltaBuilder= new PlanModelDeltaBuilder($this, this.fAttributeRegistry);
			}
			this.fDeltaBuilderConnectionCounter+= 1;
			return null;
		});
		this.fExecutionEnv.runWithLock(connectRunnable, this.fgMutex);
		return this.fDeltaBuilder;
	},

	disconnectDeltaBuilder: function() {
		if (!(this.fDeltaBuilderConnectionCounter > 0)) Assert.fail("this.fDeltaBuilderConnectionCounter > 0", "PlanModel:354");
		var disconnectRunnable= dojo.hitch(this, function() {
			this.fDeltaBuilderConnectionCounter-= 1;
			if (this.fDeltaBuilderConnectionCounter === 0) {
				var builder= this.fDeltaBuilder;
				builder.processChanges(this.fListenerList);
				this.fDeltaBuilder= null;
			}
			return null;
		});
		this.fExecutionEnv.runWithLock(disconnectRunnable, this.fgMutex);
	},

	//fAttrInitMap: null,

	initialize: function(attributeIds, planElements, future /*, flags... */ ) {
		var flags= Array.prototype.slice.call(arguments, 3);
		if (attributeIds == null || attributeIds.length === 0 || planElements == null) {
			future.callback(null);
			return ;
		}
		this.fExecutionEnv.runWithLock(dojo.hitch(this, function() {
			var isRefresh= Flag.contains(flags, Flag.Refresh);
			var isEmpty= planElements.length === 0;
			var requiredAttributes= this.fAttributeRegistry.getAllDependencies(attributeIds, function(attribute) {
				return isRefresh || isEmpty || !PlanElementProfile.isInitializedForAll(attribute, planElements);
			});
			var attrCnt= requiredAttributes.length;
			if (attrCnt === 0) {
				future.callback(null);
				return null;
			}
			var attributesCounter= new CountingFuture(attrCnt, future);
			var monitor= future.getProgressMonitor();
			monitor.beginTask(Messages.PlanModel_MONITOR_LOAD_DATA, attrCnt);
			var workerScheduled= this.attrInitWorkerIsAlive();
			var $subject14= requiredAttributes;
			var $length14= $subject14.length;
			for (var $count14= 0; $count14 < $length14; $count14++){
				var attr= $subject14[$count14];
				if ((attr.getId() in this.fAttrInitMap)) {
					this.fAttrInitMap[attr.getId()].merge(planElements, isRefresh, attributesCounter);
				} else {
					this.fAttrInitMap[attr.getId()]= new AttributeData(planElements, isRefresh, attributesCounter);
				}
			}
			if (!workerScheduled) {
				this.fExecutionEnv.newWorker(this.fAttrInitWorker).schedule(25);
			}
			return null;
		}), this.fgMutex);
	},

	attrInitWorkerIsAlive: function() {
		return this.fCurrentInitializationContext != null || jdojo.getProperties(this.fAttrInitMap).length !== 0;
	},

	//fCurrentInitializationContext: null,

	//fAttrInitWorker: null,

	//fAttributeInitializeCalledAtLeastOnce: null,

	doInitializeAttributes: function(context, attributes, attrData, future) {
		this.fExecutionEnv.newWorker(dojo.hitch(this, function() {
			var onAttributeInitialized= new CountingFuture(2 * attributes.length, future);
			context.startBatch(attributes);
			var $subject18= attributes;
			var $length18= $subject18.length;
			for (var $count18= 0; $count18 < $length18; $count18++){
				var attribute= $subject18[$count18];
				var attributeData= attrData[attribute.getId()];
				var refreshPlanElements= attributeData.getPlanElements(true);
				if (refreshPlanElements.length > 0) {
					this.doInitializeAttribute2(context, attribute, refreshPlanElements, onAttributeInitialized, [Flag.Refresh]);
					this.fAttributeInitializeCalledAtLeastOnce[attribute.getId()]= true;
				} else {
					onAttributeInitialized.callback(null);
				}
				var otherPlanElements= PlanElementProfile.subsetOfUninitialized(attribute, attributeData.getPlanElements(false));
				if (otherPlanElements.length > 0 || !(attribute.getId() in this.fAttributeInitializeCalledAtLeastOnce)) {
					this.doInitializeAttribute2(context, attribute, otherPlanElements, onAttributeInitialized, []);
					this.fAttributeInitializeCalledAtLeastOnce[attribute.getId()]= true;
				} else {
					onAttributeInitialized.callback(null);
				}
			}
			context.endBatch();
			var args= [];
			dojo.publish("/apt/model/attributesInitialized", args);
			return IExecutionEnvironment.DONE;
		})).schedule(0);
	},

	doInitializeAttribute2: function(context, attribute, planElementsSubset, future, flags) {
		context.attributesTimestamp[attribute.getId()]= new Date().getTime();
		var onAttributeInit= new Future();
		onAttributeInit.setCallback(dojo.hitch(this, function(result) {
			delete context.attributesTimestamp[attribute.getId()];
			var $subject19= planElementsSubset;
			var $length19= $subject19.length;
			for (var $count19= 0; $count19 < $length19; $count19++){
				var planElement= $subject19[$count19];
				if (!planElement.isDefined(attribute)) {
					planElement.define(attribute, undefined);
				} else {
					this.fDeltaBuilder.changed(planElement, attribute, undefined, planElement.getAttributeValue(attribute));
				}
			}
		}));
		onAttributeInit.setErrCallback(function(result) {
			delete context.attributesTimestamp[attribute.getId()];
		});
		try {
			var functionName= "initialize";
			var args= [this, planElementsSubset, future.chain(onAttributeInit)].concat(flags);
			attribute[functionName].apply(attribute, args);
		} catch (e) {
			if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
				future.errback(e);
			} else {
				throw e;
			}
		}
	},

	$interfaces: {
		'com.ibm.team.apt.api.client.IPlanModel': true
	}
});
var AttributeData= dojo.declare("com.ibm.team.apt.shared.client.internal.model.PlanModel.AttributeData", null, {
	"-chains-": { constructor: "manual" },

	//fPlanElements: null,

	//fRefreshingPlanElements: null,

	//fFuture: null,

	constructor: function(planElements, isRefresh, future) {
		this.fPlanElements= {};
		this.fRefreshingPlanElements= {};
		var $subject9= planElements;
		var $length9= $subject9.length;
		for (var $count9= 0; $count9 < $length9; $count9++){
			var planElement= $subject9[$count9];
			this.fPlanElements[planElement.getIdentifier()]= planElement;
		}
		if (isRefresh) {
			var $subject10= planElements;
			var $length10= $subject10.length;
			for (var $count10= 0; $count10 < $length10; $count10++){
				var planElement= $subject10[$count10];
				this.fRefreshingPlanElements[planElement.getIdentifier()]= true;
			}
		}
		this.fFuture= future;
	},

	merge: function(planElements, isRefresh, future) {
		var $subject11= planElements;
		var $length11= $subject11.length;
		for (var $count11= 0; $count11 < $length11; $count11++){
			var planElement= $subject11[$count11];
			this.fPlanElements[planElement.getIdentifier()]= planElement;
		}
		if (isRefresh) {
			var $subject12= planElements;
			var $length12= $subject12.length;
			for (var $count12= 0; $count12 < $length12; $count12++){
				var planElement= $subject12[$count12];
				this.fRefreshingPlanElements[planElement.getIdentifier()]= true;
			}
		}
		this.fFuture= this.fFuture.chain(future);
	},

	getPlanElements: function(isRefresh) {
		var result= [];
		var $subject13= jdojo.getValues(this.fPlanElements);
		var $length13= $subject13.length;
		for (var $count13= 0; $count13 < $length13; $count13++){
			var planElement= $subject13[$count13];
			if ((planElement.getIdentifier() in this.fRefreshingPlanElements) === isRefresh) {
				result.push(planElement);
			}
		}
		return result;
	}
});
var AttributeInitializationContext= dojo.declare("com.ibm.team.apt.shared.client.internal.model.PlanModel.AttributeInitializationContext", null, {
	"-chains-": { constructor: "manual" },

	//attributesTimestamp: null,

	//loaders: null,

	constructor: function() {
		this.attributesTimestamp= {};
	},

	startBatch: function(attributes) {
		this.loaders= {};
		var $subject20= attributes;
		var $length20= $subject20.length;
		for (var $count20= 0; $count20 < $length20; $count20++){
			var attribute= $subject20[$count20];
			var loader= attribute.getAdapter(IBatchLoadingSupport);
			if (loader != null) {
				this.loaders[loader.getIdentifier()]= loader;
			}
		}
		var $subject21= jdojo.getProperties(this.loaders);
		var $length21= $subject21.length;
		for (var $count21= 0; $count21 < $length21; $count21++){
			var identifier= $subject21[$count21];
			this.loaders[identifier].prepareBatch();
		}
	},

	endBatch: function() {
		var $subject22= jdojo.getProperties(this.loaders);
		var $length22= $subject22.length;
		for (var $count22= 0; $count22 < $length22; $count22++){
			var identifier= $subject22[$count22];
			this.loaders[identifier].processBatch();
		}
	}
});

PlanModel.fgIdPool= 0;

})();
